/*TECNISA - TECNOLOGIA EM INFORMTICA

NOME: ATUALIZA_MOVIEST

DESCRIO:
AUALIZA_INSERT_ITLANCTOEST
ATUALIZA OS CAMPOS CDFILIMOVI, DTLANCMOVI DA TABELA DE ITLANCTOEST
A PARTIR DOS VALORES GRAVADOS NOS CAMPOS SIMILARES DA TABELA LANCTOESTOQ.

AUALIZA_UPDATE_LANCTOESTOQ
ATUALIZA O CAMPO DTLANCMOVI DA TABELA DE ITLANCTOEST A PARTIR
DO VALOR GRAVADO NO CAMPO SIMILAR DA TABELA LANCTOESTOQ.

CRIAO:
16/07/99 - ROBERTO, NEWTON E SABAR
CONVERTIDO PARA SQL-SERVER POR ROBERT
*/

--ATUALIZA_INSERT_LANCTOEST
IF EXISTS (SELECT
              NAME
           FROM
              SYSOBJECTS
           WHERE
	           NAME = 'ATUALIZA_INSERT_LANCTOESTOQ' AND
	           TYPE = 'TR')

DROP TRIGGER ATUALIZA_INSERT_LANCTOESTOQ
GO

CREATE TRIGGER ATUALIZA_INSERT_LANCTOESTOQ
ON LANCTOESTOQ
FOR INSERT

AS

DECLARE @V_NEW_IDENTRSAIDOP VARCHAR(01);
DECLARE @V_NEW_CDTIPOOPER   VARCHAR(02);
DECLARE @V_NEW_CDFILIAL     VARCHAR(04);
DECLARE @V_NEW_NRLANCTONF   VARCHAR(10);
DECLARE @V_NEW_NRLANCESTQ   VARCHAR(10);
DECLARE @V_NEW_IDTPLANCTO   VARCHAR(01);

DECLARE @V_IDNFRETIND       VARCHAR(01);

BEGIN

   DECLARE C_INSERTED CURSOR FOR
   SELECT IDENTRSAIDOP, CDTIPOOPER, NRLANCTONF, CDFILIAL, NRLANCESTQ, IDTPLANCTO
     FROM INSERTED

   OPEN C_INSERTED;

   FETCH NEXT FROM C_INSERTED INTO @V_NEW_IDENTRSAIDOP, @V_NEW_CDTIPOOPER,
                                   @V_NEW_NRLANCTONF,   @V_NEW_CDFILIAL,
                                   @V_NEW_NRLANCESTQ,   @V_NEW_IDTPLANCTO;

   WHILE (@@FETCH_STATUS = 0) BEGIN

      SELECT @V_NEW_IDENTRSAIDOP = N.IDENTRSAIDOP,
             @V_NEW_CDTIPOOPER   = N.CDTIPOOPER,
             @V_IDNFRETIND = ISNULL(T.IDNFRETIND, 'N')
        FROM NOTAFISCAL N, TIPOOPERAC T
       WHERE N.IDENTRSAIDOP = T.IDENTRSAIDOP
         AND N.CDTIPOOPER   = T.CDTIPOOPER
         AND N.CDFILIAL     = @V_NEW_CDFILIAL 
         AND N.NRLANCTONF   = @V_NEW_NRLANCTONF;
      
      IF (@V_NEW_IDENTRSAIDOP IS NOT NULL) AND (@V_NEW_CDTIPOOPER IS NOT NULL) BEGIN
         IF (@V_IDNFRETIND = 'S') AND (@V_NEW_IDTPLANCTO = '4') BEGIN
            UPDATE LANCTOESTOQ
               SET CDTIPOOPER    = NULL,
                   IDENTRSAIDOP  = NULL
             WHERE CDFILIAL   = @V_NEW_CDFILIAL  
               AND NRLANCESTQ = @V_NEW_NRLANCESTQ;
         END ELSE BEGIN
            UPDATE LANCTOESTOQ
               SET CDTIPOOPER    = @V_NEW_CDTIPOOPER,
                   IDENTRSAIDOP  = @V_NEW_IDENTRSAIDOP
             WHERE CDFILIAL   = @V_NEW_CDFILIAL  
               AND NRLANCESTQ = @V_NEW_NRLANCESTQ;
         END;
      END ELSE BEGIN
         UPDATE LANCTOESTOQ
            SET CDTIPOOPER    = @V_NEW_CDTIPOOPER,
                IDENTRSAIDOP  = @V_NEW_IDENTRSAIDOP
          WHERE CDFILIAL   = @V_NEW_CDFILIAL  
            AND NRLANCESTQ = @V_NEW_NRLANCESTQ;
      END;

      FETCH NEXT FROM C_INSERTED INTO @V_NEW_IDENTRSAIDOP, @V_NEW_CDTIPOOPER,
                                      @V_NEW_NRLANCTONF,   @V_NEW_CDFILIAL,
                                      @V_NEW_NRLANCESTQ,   @V_NEW_IDTPLANCTO;
   END;

   CLOSE C_INSERTED;
   DEALLOCATE C_INSERTED;

END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'ATUALIZA_INSERT_LANCTOESTOQ','6.00.xxx';
GO
